{
  Modifique o exercicio anterior, checando se as datas de aniversario introduzidas
  sao validas.
}


program OrdemCronologica;
(* Recebe como entrada uma lista de nomes de pessoas com suas respectivas datas *)
(* de nascimento e retorna como saida essa lista em ordem cronologica            *)

const
   N = 10;
type
   tMeses = set of 1..12;
   tNome = string[50];
   tData = record
                 dia, mes, ano : integer;
           end;
   tDataDeNascimento = record
    						 nome : tNome;
                             data : tData;
                       end;
   tNascimento = array [1..N] of tDataDeNascimento;

var
   i : integer;
   aniversariante : tNascimento;
   mes30, mes31, mesFevereiro : tMeses;

procedure OrdenaCronologicamente(var aniv : tNascimento);
(* Ordena uma lista de nomes de pessoas com suas respectivas datas de nascimento *)
(* cronologicamente (i.e., da maior para a menor idade)                          *)

var
   i: integer;
   aux : tDataDeNascimento;
   ordenado : boolean;

begin
   (* Ordena, do menor para o maior, os anos das datas *)
   ordenado := false;
   while (not ordenado) do begin
       ordenado := true;
       for i := 1 to (N-1) do
           if (aniv[i].data.ano > aniv[i+1].data.ano) then begin
               ordenado := false;
               aux := aniv[i];
               aniv[i] := aniv[i+1];
               aniv[i+1] := aux;
           end;
   end;

   (* Ordena os meses, do maior para o menor, das datas de mesmo ano *)
   ordenado := false;
   while (not ordenado) do begin
       ordenado := true;
       for i := 1 to (N-1) do
           if ((aniv[i].data.ano = aniv[i+1].data.ano) and (aniv[i].data.mes > aniv[i+1].data.mes)) then begin
               ordenado := false;
               aux := aniv[i];
               aniv[i] := aniv[i+1];
               aniv[i+1] := aux;
           end;
   end;

   (* Ordena os dias, do maior para o menor, das datas de mesmo ano e mes *)
   ordenado := false;
   while (not ordenado) do begin
       ordenado := true;
       for i := 1 to (N-1) do
           if (aniv[i].data.ano = aniv[i+1].data.ano) then
               if ((aniv[i].data.mes = aniv[i+1].data.mes) and (aniv[i].data.dia > aniv[i+1].data.dia)) then begin
                   ordenado := false;
                   aux := aniv[i];
                   aniv[i] := aniv[i+1];
                   aniv[i+1] := aux;
               end; (* if *)
   end; (* while *)
end; (* OrdenaCronologicamente *)

procedure VerificaData (var aniv : tDataDeNascimento);
(* Verifica se uma data introduzida eh valida *)

begin
   with aniv do begin
       while (data.mes > 12) do begin
           writeln('Data Invalida! Mes Invalido. Digite a data completa novamente.');
           readln(data.dia,data.mes,data.ano);
       end;
       if (data.mes in mes30) then
           while (data.dia > 30) do begin
               writeln('Data Invalida! Esse mes possui 30 dias. Digite o dia novamente.');
               readln(data.dia);
           end;
       if (data.mes in mes31) then
           while (data.dia > 31) do begin
               writeln('Data Invalida! Esse mes possui 31 dias. Digite o dia novamente.');
               readln(data.dia);
           end;
       if (data.mes in mesFevereiro) then
           while (data.dia > 29) do begin
               writeln('Data Invalida! Fevereiro possui 29 dias. Digite o dia novamente.');
               readln(data.dia);
           end;
   end;
end;

begin
   mes30 := [04, 06, 09, 11];
   mes31 := [01, 03, 05, 07, 08, 10, 12];
   mesFevereiro := [02];

   (* Leitura do nome e da data de nascimento *)
   for i := 1 to N do begin
       writeln('Digite o nome e a data de nascimento (separada por enter) do individuo :');
       with aniversariante[i] do
           readln(nome, data.dia, data.mes, data.ano);
       VerificaData(aniversariante[i]);   (* Verificacao da validade da data de nascimento *)
   end;

   (* Ordenacao cronologica das datas de nascimentos *)
   OrdenaCronologicamente(aniversariante);

   (* Impressao da lista *)
   writeln('Datas de nascimentos :');
   for i := 1 to N do
       with aniversariante[i] do
           writeln(nome,'-',data.dia,'/',data.mes,'/',data.ano);
end.