{
  Uma empresa tem uma lista de registros de empregados cada um contendo os
  seguintes componentes:

  nome (string);
  idade (valor inteiro);
  salario (valor real);
  sexo ('M' ou 'F');

  Faca um programa que leia esta lista de registros e imprima todas as
  informacoes a respeito da funcionaria mais remunerada da companhia.
}

program RegistroDeEmpregados;
(* Verifica qual a funcionaria mais remunerada da empresa *)

const
   EMPREGADOS = 7;
   MAX_DE_CARACT = 80;
type
   tNome = string[MAX_DE_CARACT];
   tIdade = 1..70;
   tRegistrodeEmpregado = record
                                nome : tNome;
                                sexo : char;
                                idade : tIdade;
                                salario : real;
                          end;
   tEmpregado = array [1..EMPREGADOS] of tRegistroDeEmpregado;
var
   empregado : tEmpregado;
   i, numeroDeEmpregados, indiceDoArranjo : integer;

procedure LeRegistro(var empresa : tEmpregado; pessoas : integer);
(* Le o registro que contem os dados do empregado *)

var
   i : integer;

begin
   for i := 1 to pessoas do
       with empresa[i] do begin
           (* Leitura do nome do(a) empregado(a) *)
           writeln('Digite o nome do(a) funcionario(a) :');
           readln(nome);
           (* Leitura do sexo do(a) empregado(a) *)
           writeln('Digite o sexo (M/F) de ',nome,' :');
           readln(sexo);
           (* Le novamente o sexo do(a) empregado(a) caso o sexo anterior *)
           (* seja diferente de "M" e "F"                                 *)
           while ((sexo<>'M') and (sexo<>'F')) do begin
               writeln('Erro.Digite "M" (masculino) ou "F" (feminino) :');
               readln(sexo);
           end;
           (* Leitura da idade do(a) empregado(a) *)
           writeln('Digite a idade de ',nome,' :');
           readln(idade);
           (* Leitura da idade do(a) empregado(a) *)
           writeln('Digite o salario de ',nome,' (em reais) :');
           readln(salario);
       end;
end; (* LeRegistro *)

procedure MulherMaisRemunerada(var empresa : tEmpregado; pessoas : integer; var indiceMaior : integer);
(* Verifica qual a funcionaria mais remunerada da empresa *)

var
   i : integer;
   maiorSalario : real;

begin
   (* Considera-se que a empregada mais remunerada eh a primeira a ser  *)
   (* encontrada no arranjo                                             *)
   maiorSalario := empresa[indiceMaior].salario; (* Inicializacao com o  *)
                                                 (* salario da primeira  *)
                                                 (* empregada localizada *)

   (* Verifica se ha outras empregadas e se o seu salario eh maior *)
   for i := (indiceMaior + 1) to pessoas do
       with empresa[i] do
           if (sexo = 'F') then
               (* Verifica se o salario da outra empregada eh maior que o *)
               (* da primeira                                             *)
               if (salario > maiorSalario) then begin
                   maiorSalario := salario; (* Armazena o maior salario *)

                   indiceMaior := i; (* Guarda o indice do arranjo que       *)
                                     (* corresponde ao indice da mulher mais *)
                                     (* remunerada                           *)
               end;
end;

procedure Escrita(var empresa : tEmpregado; indice : integer);
(* Imprime os dados dos empregados *)

begin
   with empresa[indiceDoArranjo] do begin
       writeln('Nome : ',nome);
       writeln('Sexo : ',sexo);
       writeln('Idade : ',idade,' anos');
       writeln('Salario : R$ ',salario:8:2);
    end;
end;

begin
   (* Leitura do numero de empregados *)
   writeln('Introduza o numero de empregados :');
   readln(numeroDeEmpregados);

   (* Le novamente o numero de empregados, caso o numero anterior seja maior *)
   (* que o permitido                                                        *)
   while (numeroDeEmpregados > EMPREGADOS) do begin
       writeln('Erro.Digite um valor menor ou igual a ',EMPREGADOS,' :');
       readln(numerodeEmpregados);
   end;

   LeRegistro(empregado,numeroDeEmpregados);

   (* Localizacao, no arranjo, do indice da primeira empregada *)
   i := 0;
   if (i <= numeroDeEmpregados) then
       repeat begin
           i := i+1; (* Incrementa-se o i *)
           if (empregado[i].sexo = 'F') then
               indiceDoArranjo := i (* Armazena o indice da primeira empregada *)
           else
               indiceDoArranjo := 0;
       end;
       (* O "repeat" eh encerrado quando eh localizado o indice da primeira *)
       (* empregada ou quando o "i" assumir um valor maior que o numero de  *)
       (* empregados existentes                                             *)
       until ((empregado[i].sexo = 'F') or (i > numeroDeEmpregados));

   if (indiceDoArranjo > 0) then begin (* Testa se o indice encontrado eh *)
                                       (* maior que 0                     *)
       writeln;
       writeln('Os dados da funcionaria mais remunerada sao :');
       MulherMaisRemunerada(empregado,numeroDeEmpregados,indiceDoArranjo);
       Escrita(empregado,indiceDoArranjo);
   end
   else begin
       writeln; (* Pula linha no meio de saida *)
       writeln ('A empresa nao contem funcionarias.');
   end;
end.





